﻿/*******************************************************************************
用于演示浏览器通用组件的调用，以加法计算为例 
*******************************************************************************/

//回调类型
var eCallbackUnknown = 0;
var eFunctionResult = 1;
var eNotice = 2;

//函数返回值回调，对应于哪个函数 
var eUnknown		= 0;
var eTestPlus		= 1 << 0;	//测试加法  
var eGetVersion     = 1 << 1;

var testControl = null;
function TestPlusControl() 
{
    var self = this;
	this.downloadUrl = "http://www.ggniu.cn/download/EngineInstall.exe";
	this.base = new NiuniuControlObject("40111,40112", "NiuniuWebControl", "application/x-webcontrolenginedemo", "Zwl/k8Nu+04ONXvFw01uK/lBPL8ZNTEb8ZK7qL4qUAc=");    
	this.functionCallbackMap = {};
	this.PluginLoaded = null;
	this.PluginUnload = null;
	this.doShowDownload = null;
	this.OnControlNotice = function(obj){ alert("error");}
	
	
	this.Init = function()
	{	
		self.base.NiuniuAuthKey = "niuniu";		
		//是否需要根据场景使用确定的identifier，如果不需要的话，随机一个值就好
		var timestamp = (new Date()).valueOf();
		self.base.identifier = '' + timestamp;
		//设置控件加载完成以及回调函数
		self.base.OnInvokeCallback = self.OnInvokeCallback;
		self.base.PluginLoadedCallback = self.PluginLoadedCallback;
		self.base.OnConnectFailed = self.OnConnectFailed;
		
		//初始化控件 
		self.base.InitNiuniucontrol();
	}
	this.isUseful = function()
	{
		return self.base.isUseful();
	}
		
	this.ShowDownLoad = function(forceDownload)
	{
		if(self.doShowDownload != null)
		{
			self.doShowDownload(forceDownload);
		}
		else
		{
			base.WriteLog("self.doShowDownload is null.");
		}
	}
	
    this.NewControlParamObject = function(type, callback)
    {  
        var obj = new Object(); 
        obj.cmdType = type;  
		obj.identifier = self.base.identifier;
		
		//授权信息 
		obj.clientUrl = window.location.host;
		obj.webcontrolAuth = self.base.webcontrolAuth;
		//此处绑定函数调用类型的回调函数
		if(callback != null && callback != undefined && typeof callback == 'function')
		{
			self.functionCallbackMap[type] = callback;
		}
        return obj; 
    } 

	this.StartEngine = function()
	{
		var obj = new Object();
		obj.authKey = self.base.NiuniuAuthKey;
		obj.cmdType = -1;
		var json = $.toJSON(obj);
        var controlRet = self.base.doInvoke(json, true);
		//从返回值来解析显示  	
		if(controlRet == emcontrolFailed)
		{
			self.ShowDownLoad(true);
		}
		else if(controlRet == emcontrolUnknown)
		{
			self.ShowDownLoad(false);
		}
	}
	
	this.TestPlus = function(number1, number2, callback)
	{
		var obj = self.NewControlParamObject(eTestPlus, callback);
		obj.number1 = number1;
		obj.number2 = number2;
		var json = $.toJSON(obj);        
        return self.base.doInvoke(json, true);
	}
	
	this.GetVersion = function(callback)
	{	
		var obj = self.NewControlParamObject(eGetVersion, callback);
		//如果同时加载多个控件，则传此值，用于控制要获取哪个控件的版本号 
		obj.controlName = "niuniuwebcontrol";
		var json = $.toJSON(obj);
        return self.base.doInvoke(json, false);			
	}
		
	/*当控件成功加载后回调的的函数，您可以在此控制相应的UI显示  */
	this.PluginLoadedCallback = function(success)
	{
		if(self.PluginLoaded != null)
		{
			self.PluginLoaded(success);
		}
		if(success)
		{
			//如果是上次未完成的命令需要连接上后继续发送的，可以在此处再发一次 
			
		}
	}
	
	/*当JS在经过重试的情况下，还是未连接成功，则会回调此函数，进行UI提示或其他的业务处理  */
	this.OnConnectFailed = function(isReconnect)
	{
		if(isReconnect)
		{
			if(self.PluginUnload != null)
			{
				self.PluginUnload();
			}
		}
		else
		{			
			self.PluginLoadedCallback(false);
		}
	}
	
	
	this.OnFunctionResult = function(obj, content)
	{
		var func = self.functionCallbackMap[obj.callType];		
		delete self.functionCallbackMap[obj.callType];
		if(func != null && func != undefined)
		{
			func(obj);
		}
		return;
	}
	
	/*此处是控件数据交互的回调函数(包含接口返回值以及控件内部主动推送的回调信息)，请分类处理 */
	this.OnInvokeCallback = function(obj, content) 
	{
		if(obj.type < 0)
		{
			//需要重新安装控件
			self.ShowDownLoad(true);
			return;
		}
		switch(obj.type)
		{
			case eFunctionResult:
			{
				self.OnFunctionResult(obj, content);
			}
			break;
			case eNotice:
			{
				self.OnControlNotice(obj);
			}
			break;
			case eCallbackUnknown:
			default:
			break;
		}   
	}
}